﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=2.2
@EndOfDesignText@
'Static code module
Sub Process_Globals
	Private fx As JFX
	Private VERSION As Double = 1.0
	Private wsh As WebSocketHandler
	Private id As String
	Private pingTimer As Timer
	Private lastServerPong As Long
	Type Message (id As String, Text As String)
	Private ReconnectTimer As Timer
End Sub

Public Sub Create
	id = GlobalParams.WSid
	If pingTimer.IsInitialized=False Then pingTimer.Initialize("pingTimer", 10000)
	If ReconnectTimer.IsInitialized=False Then ReconnectTimer.Initialize("ReconnectTimer", 5000)
	Connect
End Sub

Private Sub Connect
	Dim wsh As WebSocketHandler
	wsh.Initialize(Me, "wsh", GlobalParams.RDCUser, GlobalParams.RDCPW)
	wsh.Connect2(GlobalParams.WSLink)
End Sub

Sub wsh_ServerReady(Params As List)
	Dim m As Map
	m.Initialize
	m.Put("id", id)
	m.Put("version", VERSION)
	wsh.SendEventToServer("Device_id", m)
End Sub

'this is messages from the server 
Sub wsh_NewMessage(Params As List)
'	Log("wsh_NewMessage")
	Dim messages As List
	messages.Initialize
	Dim ids As List
	ids.Initialize
	For i = 0 To Params.Size - 1 Step 2
		Dim m As Message
		m.Initialize
		m.id = Params.Get(i)
		m.Text = Params.Get(i + 1)
'		Log("msgID= " & m.id)
'		Log("msgText= " & m.Text)
		messages.Add(m)
		ids.Add(m.id)
	Next
	WSHelper.NewMessage(messages)
	Dim mm As Map
	mm.Initialize
	mm.Put("ids", ids)
	wsh.SendEventToServer("Device_MessageDelivered", mm)
End Sub

Sub wsh_Connected
	WSHelper.UpdateStatus(wsh.ws.Connected, "")
	pingTimer.Enabled = True
	lastServerPong = DateTime.Now
End Sub

Sub wsh_Closed (Reason As String)
	WSHelper.UpdateStatus(wsh.ws.Connected, Reason)
	pingTimer.Enabled = False
	ReconnectTimer.Enabled = True
End Sub

Sub ReconnectTimer_Tick
	If wsh.ws.Connected = False Then
		Connect
	End If
	ReconnectTimer.Enabled = False
End Sub

Sub PingTimer_Tick
	'Log("PingTimer_Tick: " & wsh.ws.Connected & ", " & lastServerPong & ", "  & (lastServerPong + 30 * DateTime.TicksPerSecond < DateTime.Now))
	If wsh.ws.Connected = False Then Return
	
	If lastServerPong + 30 * DateTime.TicksPerSecond < DateTime.Now Then
		'Log("Closing connection after 30 seconds of no response")
		wsh.Close
	Else
		Dim m As Map
		m.Initialize
		wsh.SendEventToServer("Device_Ping", m)
	End If
End Sub

Sub wsh_Pong(Params As List)
	lastServerPong = DateTime.Now
End Sub

Public Sub Close
	If wsh.ws.Connected Then
		wsh.Close
	End If
End Sub

Public Sub SendMessageToAll(Msg As String)
'	Log("SendMessageToAll")
'	Log(Msg)
	wsh.SendEventToServer("Device_MessageFrom", CreateMap("text": "Msg from App1: " & CRLF & Msg))
End Sub

Public Sub IsInitialised As Boolean
	Return wsh.IsInitialized
End Sub
